Index: /trunk/src/org/expeditee/items/Line.java
===================================================================
--- /trunk/src/org/expeditee/items/Line.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/Line.java	(revision 1102)
@@ -19,15 +19,4 @@
 package org.expeditee.items;
 
-import java.awt.BasicStroke;
-import java.awt.Color;
-import java.awt.Graphics2D;
-import java.awt.Point;
-import java.awt.Polygon;
-import java.awt.Rectangle;
-import java.awt.RenderingHints;
-import java.awt.Shape;
-import java.awt.Stroke;
-import java.awt.geom.AffineTransform;
-import java.awt.geom.Point2D;
 import java.util.ArrayList;
 import java.util.Collection;
@@ -37,5 +26,15 @@
 import java.util.List;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.core.Colour;
+import org.expeditee.core.Dimension;
+import org.expeditee.core.Fill;
+import org.expeditee.core.Point;
+import org.expeditee.core.Stroke;
+import org.expeditee.core.bounds.AxisAlignedBoxBounds;
+import org.expeditee.core.bounds.CombinationBoxBounds;
+import org.expeditee.core.bounds.PolygonBounds;
+import org.expeditee.gio.EcosystemManager;
+import org.expeditee.gio.GraphicsManager;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.Frame;
 import org.expeditee.gui.FrameGraphics;
@@ -59,8 +58,7 @@
 
 	
-	public static Polygon createArrowheadPolygon(double x0, double y0, float arrowLength0, double arrowRatio0, double arrowNibPerc0) 
+	public static PolygonBounds createArrowheadPolygon(double x0, double y0, float arrowLength0, double arrowRatio0, double arrowNibPerc0) 
 	{
-		
-		Polygon arrowhead = new Polygon();
+		PolygonBounds arrowhead = new PolygonBounds();
 	    
 		int ix0 = (int)Math.round(x0);
@@ -73,12 +71,9 @@
 		int flange_iy_left = (int) Math.round((y0 - flange_y_width));
 		int flange_iy_right = (int) Math.round((y0 + flange_y_width));
-				
-		
-		arrowhead.addPoint(ix0, iy0);
-		arrowhead.addPoint(flange_ix_project, flange_iy_left);
-		
-		arrowhead.addPoint(ix_nib, iy0);
-		
-		arrowhead.addPoint(flange_ix_project, flange_iy_right);
+		
+		arrowhead.addPoint(new Point(ix0, iy0));
+		arrowhead.addPoint(new Point(flange_ix_project, flange_iy_left));
+		arrowhead.addPoint(new Point(ix_nib, iy0));
+		arrowhead.addPoint(new Point(flange_ix_project, flange_iy_right));
 		
 		return arrowhead;
@@ -95,5 +90,5 @@
 
 	// brush strokes used for painting this line and highlighting
-	private Stroke _lineStroke = new BasicStroke(DEFAULT_THICKNESS, CAP, JOIN, 4.0F);
+	private Stroke _lineStroke = new Stroke(DEFAULT_THICKNESS, DEFAULT_CAP, DEFAULT_JOIN);
 
 	Stroke getStroke() {
@@ -143,12 +138,10 @@
 			for (int i = 0; i < pattern.length; i++)
 				dash[i] = (float) pattern[i];
-			_lineStroke = new BasicStroke(Math.max(thick,
-					MINIMUM_PAINT_THICKNESS), CAP, JOIN, 10f, dash, 0.0f);
+			_lineStroke = new Stroke(Math.max(thick, MINIMUM_PAINT_THICKNESS), DEFAULT_CAP, DEFAULT_JOIN, dash, 0.0f);
 		} else {
-			_lineStroke = new BasicStroke(Math.max(thick,
-					MINIMUM_PAINT_THICKNESS), CAP, JOIN);
-		}
-
-		updatePolygon();
+			_lineStroke = new Stroke(Math.max(thick, MINIMUM_PAINT_THICKNESS), DEFAULT_CAP, DEFAULT_JOIN);
+		}
+
+		invalidateBounds();
 	}
 
@@ -240,5 +233,5 @@
 			_start = start;
 			_start.addLine(this);
-			updatePolygon();
+			invalidateBounds();
 		}
 	}
@@ -258,5 +251,5 @@
 			_end = end;
 			_end.addLine(this);
-			updatePolygon();
+			invalidateBounds();
 		}
 	}
@@ -317,9 +310,7 @@
 			for (int i = 0; i < pattern.length; i++)
 				dash[i] = (float) pattern[i];
-			_lineStroke = new BasicStroke(Math.max(thick, MINIMUM_THICKNESS),
-					CAP, JOIN, 10f, dash, 0.0f);
+			_lineStroke = new Stroke(Math.max(thick, MINIMUM_THICKNESS), DEFAULT_CAP, DEFAULT_JOIN, dash, 0.0f);
 		} else
-			_lineStroke = new BasicStroke(Math.max(thick, MINIMUM_THICKNESS),
-					CAP, JOIN);
+			_lineStroke = new Stroke(Math.max(thick, MINIMUM_THICKNESS), DEFAULT_CAP, DEFAULT_JOIN);
 
 		if (_start.getLinePattern() != pattern)
@@ -333,36 +324,25 @@
 
 	@Override
-	public void paint(Graphics2D g) {
-		if (!isVisible())
-			return;
-
-		// Dont paint lines with thickness 0 if they are the border on a filled
-		// shape
-		if (dontPaint())
-			return;
-
-		g.setColor(getPaintColor());
+	public void paint()
+	{
+		if (!isVisible()) return;
+
+		// Dont paint lines with thickness 0 if they are the border on a filled shape
+		if (dontPaint()) return;
 
 		// if (this._mode == Item.SelectedMode.Disconnect)
 		// System.out.println("Disconnect mode!");
-		g.setStroke(_lineStroke);
 		// Get a path of points
-		int[][][] paths = getPaths();
-		for (int i = 0; i < paths.length; i++) {
-			int[][] path = paths[i];
-			int last = path[0].length - 1;
-			if (path[0][0] == path[0][last] && path[1][0] == path[1][last]) {
-				g.drawPolygon(path[0], path[1], last);
-			} else {
-				g.drawPolyline(path[0], path[1], last + 1);
-			}
-		}
+		PolygonBounds[] paths = getPaths();
+		for (PolygonBounds path : paths) {
+			EcosystemManager.getGraphicsManager().drawPolygon(path, null, null, 0.0f, null, getPaintColor(), _lineStroke);
+		}
+		
 		// paint the arrowhead (if necessary)
-		paintArrows(g);
-
-		if (showLineHighlight() && isHighlighted()) {
-			g.setColor(getHighlightColor());
-			g.setStroke(HIGHLIGHT_STROKE);
-			((Graphics2D) g).draw(this.getArea());
+		paintArrows();
+
+		if (shouldShowLineHighlight() && isHighlighted()) {
+			PolygonBounds poly = (PolygonBounds) getBounds();
+			EcosystemManager.getGraphicsManager().drawPolygon(poly, null, null, 0.0f, null, getHighlightColor(), HIGHLIGHT_STROKE);
 		}
 	}
@@ -371,8 +351,8 @@
 		// enable invisible shapes (for web browser divs) only when XRayMode is off
 		return getThickness() <= 0 && _start.isEnclosed()
-				&& (_start.getFillColor() != null || !FrameGraphics.isXRayMode());
-	}
-
-	protected int[][][] getPaths() {
+				&& (_start.getFillColor() != null || !DisplayController.isXRayMode());
+	}
+
+	protected PolygonBounds[] getPaths() {
 		List<List<Point>> pointPaths = new LinkedList<List<Point>>();
 		Collection<Line> visited = new HashSet<Line>();
@@ -388,22 +368,22 @@
 		}
 		// Put the paths into int arrays
-		int[][][] paths = new int[pointPaths.size()][][];
+		PolygonBounds[] paths = new PolygonBounds[pointPaths.size()];
 		Iterator<List<Point>> iter = pointPaths.iterator();
 
 		for (int i = 0; i < paths.length; i++) {
 			List<Point> pointPath = iter.next();
-			int[][] path = new int[2][pointPath.size()];
+			PolygonBounds path = new PolygonBounds();
 			paths[i] = path;
 			// Add all the x and y's to the array
-			for (int j = 0; j < path[0].length; j++) {
-				path[0][j] = pointPath.get(j).x;
-				path[1][j] = pointPath.get(j).y;
-			}
-		}
+			for (int j = 0; j < pointPath.size(); j++) {
+				path.addPoint(pointPath.get(j).x, pointPath.get(j).y);
+			}
+		}
+		
 		return paths;
 	}
 
-	protected List<Point> getPath(Collection<Line> visited,
-			LinkedList<Line> toExplore) {
+	protected List<Point> getPath(Collection<Line> visited, LinkedList<Line> toExplore)
+	{
 		LinkedList<Point> points = new LinkedList<Point>();
 		// put the start item points into our list
@@ -417,16 +397,14 @@
 	}
 
-	public void paintArrows(Graphics2D g) {
-		if (dontPaint())
-			return;
-
-		g.setColor(getPaintColor());
-		g.setStroke(new BasicStroke(getPaintThickness(), CAP,
-				BasicStroke.JOIN_MITER));
-		paintArrow(g, getStartArrow());
-		paintArrow(g, getEndArrow());
-
+	public void paintArrows()
+	{
+		if (dontPaint()) return;
+
+		paintArrow(getStartArrow());
+		paintArrow(getEndArrow());
+
+		// TODO: What is a virtual spot? cts16
 		if (_virtualSpot != null) {
-			_virtualSpot.paint(g);
+			_virtualSpot.paint();
 			invalidateVirtualSpot();
 			_virtualSpot = null;
@@ -456,11 +434,15 @@
 	 * @return
 	 */
-	private Shape getArrow(Item withArrow, Point startOffset, Point endOffset) {
-		boolean disconnectMode = withArrow._mode == Item.HighlightMode.Disconnect;
+	private PolygonBounds getArrow(Item withArrow, Point startOffset, Point endOffset)
+	{
+		boolean disconnectMode = withArrow._highlightMode == Item.HighlightMode.Disconnect;
+		
 		// only draw an arrowhead if necessary
-		if (!(this._mode == Item.HighlightMode.Disconnect && disconnectMode)
-				&& (!withArrow.hasVisibleArrow() || withArrow.getLines().size() > 1))
+		if (	!(this._highlightMode == Item.HighlightMode.Disconnect && disconnectMode) &&
+				(!withArrow.hasVisibleArrow() || withArrow.getLines().size() > 1))
+		{
 			return null;
-
+		}
+		
 		int x0, x1, y0, y1;
 
@@ -475,5 +457,5 @@
 		
 		// set the size of the disconnect indicator arrowhead
-		if (this._mode == Item.HighlightMode.Disconnect) {
+		if (this._highlightMode == Item.HighlightMode.Disconnect) {
 			arrowLength  = 15;
 			arrowRatio   = 0.3;
@@ -494,6 +476,6 @@
 		// The length of the line must at least be as long as the arrow or we
 		// wont show the arrow
-		if (length <= MINIMUM_ARROW_HEAD_LENGTH)
-			return null;
+		if (length <= MINIMUM_ARROW_HEAD_LENGTH) return null;
+		
 		if (arrowLength == AUTO_ARROWHEAD_LENGTH) {
 			arrowLength = getAutoArrowheadLength(length);
@@ -508,35 +490,25 @@
 
 		// only calculate the arrowhead polygon if necessary
-		Polygon arrowhead = withArrow.getArrowhead();
+		PolygonBounds arrowhead = withArrow.getArrowhead();
 		if (arrowhead == null || disconnectMode) {
-			arrowhead = createArrowheadPolygon(x0,y0,arrowLength,arrowRatio,arrowNibPerc); 
+			arrowhead = createArrowheadPolygon(x0, y0, arrowLength, arrowRatio, arrowNibPerc); 
 			
 			if (!disconnectMode)
-				withArrow.setArrowhead(arrowhead);
-		}
+				withArrow.setArrowhead(new PolygonBounds(arrowhead));
+		}
+		arrowhead = arrowhead.clone();
 		double rad = calcAngle((float) x0, (float) y0, (float) x1, (float) y1);
-		arrowhead.translate((x0 + length) - arrowhead.xpoints[0], y0
-				- arrowhead.ypoints[0]);
-		AffineTransform tx = AffineTransform.getRotateInstance(rad, x0, y0);
-		
-        int[] rx = new int[arrowhead.npoints];
-        int[] ry = new int[arrowhead.npoints];
-        
-        for(int i = 0; i < arrowhead.npoints; i++){
-            Point2D p = new Point2D.Double(arrowhead.xpoints[i], arrowhead.ypoints[i]);
-            tx.transform(p,p);
-            rx[i] = (int) p.getX();
-            ry[i] = (int) p.getY();
-        }
-        
-        return new Polygon(rx, ry, arrowhead.npoints);
+		arrowhead.translate((x0 + length) - arrowhead.toArray()[0].x, y0 - arrowhead.toArray()[0].y);
+		arrowhead.rotate(rad, x0, y0);
+		
+		return arrowhead;
 	}
 	
-	public Polygon getStartArrow() {
-		return (Polygon) getArrow(_start, _startOffset, _endOffset);
+	public PolygonBounds getStartArrow() {
+		return getArrow(_start, _startOffset, _endOffset);
 	}
 	
-	public Polygon getEndArrow() {
-		return (Polygon) getArrow(_end, _endOffset, _startOffset);
+	public PolygonBounds getEndArrow() {
+		return getArrow(_end, _endOffset, _startOffset);
 	}
 
@@ -544,5 +516,9 @@
 	 * Based on code from DeSL (Arrow2D) http://sourceforge.net/projects/desl/
 	 */
-	private void paintArrow(Graphics2D g, Shape arrow) {
+	private void paintArrow(PolygonBounds arrow)
+	{
+		Colour arrowColour = getPaintColor();
+		Fill arrowFill = new Fill(arrowColour);
+		Stroke arrowStroke = new Stroke(getPaintThickness(), DEFAULT_CAP, Stroke.JOIN.MITER);
 		
 		if(arrow == null) {
@@ -557,8 +533,8 @@
 		// ****
 		
-		g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
-		
-		g.draw(arrow);
-		g.fill(arrow);
+		GraphicsManager g = EcosystemManager.getGraphicsManager();
+		
+		g.setAntialiasing(true);
+		g.drawPolygon(arrow.close(), null, null, 0.0f, arrowFill, arrowColour, arrowStroke);
 	
 	}
@@ -630,4 +606,9 @@
 		return temp;
 	}
+	
+	public Item getEndPointToDisconnect(Point p)
+	{
+		return getEndPointToDisconnect(p.x, p.y);
+	}
 
 	public Item getEndPointToDisconnect(int x, int y) {
@@ -653,21 +634,21 @@
 
 		if (distStart < NORMAL_THRESHHOLD) {
-			start._mode = Item.HighlightMode.Normal;
+			start._highlightMode = Item.HighlightMode.Normal;
 			return start;
 		} else if (distEnd < NORMAL_THRESHHOLD) {
-			end._mode = Item.HighlightMode.Normal;
+			end._highlightMode = Item.HighlightMode.Normal;
 			return end;
 		} else if (distStart < DISCONNECT_THRESHHOLD) {
 			if (start.getLines().size() > 1
 					|| start.getConstraints().size() > 0)
-				start._mode = Item.HighlightMode.Disconnect;
+				start._highlightMode = Item.HighlightMode.Disconnect;
 			else
-				start._mode = Item.HighlightMode.Normal;
+				start._highlightMode = Item.HighlightMode.Normal;
 			return start;
 		} else if (distEnd < DISCONNECT_THRESHHOLD) {
 			if (end.getLines().size() > 1 || end.getConstraints().size() > 0)
-				end._mode = Item.HighlightMode.Disconnect;
+				end._highlightMode = Item.HighlightMode.Disconnect;
 			else
-				end._mode = Item.HighlightMode.Normal;
+				end._highlightMode = Item.HighlightMode.Normal;
 			return end;
 		}
@@ -677,8 +658,8 @@
 
 	@Override
-	public int setHighlightColor() {
-		super.setHighlightColor();
-
-		return Item.UNCHANGED_CURSOR;
+	public void setHighlightColorToDefault() {
+		super.setHighlightColorToDefault();
+
+		//return Item.UNCHANGED_CURSOR;
 	}
 
@@ -690,5 +671,5 @@
 	 */
 	@Override
-	public void setColor(Color c) {
+	public void setColor(Colour c) {
 		super.setColor(c);
 
@@ -698,5 +679,5 @@
 
 	@Override
-	public Color getFillColor() {
+	public Colour getFillColor() {
 		return _start.getFillColor();
 	}
@@ -882,24 +863,56 @@
 	private Item _virtualSpot = null;
 
-	public void showVirtualSpot(Item orig, int mouseX, int mouseY) {
-		if (orig.getLines().size() != 1)
-			return;
+	public void showVirtualSpot(Item orig, int mouseX, int mouseY)
+	{
+		if (orig.getLines().size() != 1) return;
 
 		// lines that are in 'connected' mode, also cannot be attached
-		if (orig.getLines().get(0).getOppositeEnd(orig).isFloating())
-			return;
+		if (orig.getLines().get(0).getOppositeEnd(orig).isFloating()) return;
 
 		Item spot = new Dot(-1, orig.getX(), orig.getY());
 		Item.DuplicateItem(orig, spot);
 		spot.setThickness(Math.max(this.getThickness(), 5));
-		if (this.getColor() != Color.RED)
-			spot.setColor(Color.RED);
-		else
-			spot.setColor(Color.BLUE);
-
+		if (!this.getColor().equals(Colour.RED)) {
+			spot.setColor(Colour.RED);
+		} else {
+			spot.setColor(Colour.BLUE);
+		}
+		
 		// unhighlight all the dots
 		for (Item conn : getAllConnected()) {
 			conn.setHighlightMode(Item.HighlightMode.None);
-		}
+			conn.setHighlightColorToDefault();
+		}
+
+		// calculate nearest point on line from spot
+		org.expeditee.core.Line line = new org.expeditee.core.Line(_start.getPosition(), _end.getPosition());
+		Point nearest = line.getPointNearestTo(spot.getPosition());
+
+		// position spot on the line
+		spot.setPosition(nearest);
+		_virtualSpot = spot;
+		invalidateVirtualSpot();
+	}
+
+	public void showVirtualSpot(int mouseX, int mouseY) {
+		Item spot = new Dot(mouseX, mouseY, -1);
+		spot.setThickness(Math.max(this.getThickness(), 5));
+		if (DEFAULT_HIGHLIGHT.equals(this.getColor()))
+			spot.setColor(ALTERNATE_HIGHLIGHT);
+		else
+			spot.setColor(DEFAULT_HIGHLIGHT);
+
+
+		// calculate nearest point on line from spot
+		org.expeditee.core.Line line = new org.expeditee.core.Line(_start.getPosition(), _end.getPosition());
+		Point nearest = line.getPointNearestTo(spot.getPosition());
+
+		// position spot on the line
+		spot.setPosition(nearest);
+		_virtualSpot = spot;
+		invalidateVirtualSpot();
+	}
+
+	public Item forceMerge(Item spot, int mouseX, int mouseY) {
 
 		// calculate nearest point on line from spot
@@ -930,76 +943,4 @@
 		// position spot on the line
 		spot.setPosition((int) x, (int) y);
-		_virtualSpot = spot;
-		invalidateVirtualSpot();
-	}
-
-	public void showVirtualSpot(int mouseX, int mouseY) {
-		Item spot = new Dot(mouseX, mouseY, -1);
-		spot.setThickness(Math.max(this.getThickness(), 5));
-		if (DEFAULT_HIGHLIGHT.equals(this.getColor()))
-			spot.setColor(ALTERNATE_HIGHLIGHT);
-		else
-			spot.setColor(DEFAULT_HIGHLIGHT);
-
-		// calculate nearest point on line from spot
-		double slope1;
-		double slope2;
-		double x, y;
-
-		slope1 = (_start.getY() - _end.getY() * 1.0)
-				/ (_start.getX() - _end.getX());
-		slope2 = -1 / slope1;
-
-		// if the line is horizontal
-		if (slope1 == 0) {
-			x = spot.getX();
-			y = _start.getY();
-			// if the line is vertical
-		} else if (slope2 == 0) {
-			x = _start.getX();
-			y = spot.getY();
-			// otherwise, the line is sloped
-		} else {
-			x = (-1 * slope2 * spot.getX() + spot.getY() - _start.getY() + slope1
-					* _start.getX())
-					/ (slope1 - slope2);
-			y = slope1 * (x - _start.getX()) + _start.getY();
-		}
-
-		// position spot on the line
-		spot.setPosition((int) x, (int) y);
-		_virtualSpot = spot;
-		invalidateVirtualSpot();
-	}
-
-	public Item forceMerge(Item spot, int mouseX, int mouseY) {
-
-		// calculate nearest point on line from spot
-		double slope1;
-		double slope2;
-		double x, y;
-
-		slope1 = (_start.getY() - _end.getY() * 1.0)
-				/ (_start.getX() - _end.getX());
-		slope2 = -1 / slope1;
-
-		// if the line is horizontal
-		if (slope1 == 0) {
-			x = spot.getX();
-			y = _start.getY();
-			// if the line is vertical
-		} else if (slope2 == 0) {
-			x = _start.getX();
-			y = spot.getY();
-			// otherwise, the line is sloped
-		} else {
-			x = (-1 * slope2 * spot.getX() + spot.getY() - _start.getY() + slope1
-					* _start.getX())
-					/ (slope1 - slope2);
-			y = slope1 * (x - _start.getX()) + _start.getY();
-		}
-
-		// position spot on the line
-		spot.setPosition((int) x, (int) y);
 
 		// Keep constraints
@@ -1018,5 +959,5 @@
 		Line temp = copy();
 
-		Frame currentFrame = DisplayIO.getCurrentFrame();
+		Frame currentFrame = DisplayController.getCurrentFrame();
 		temp.setID(currentFrame.getNextItemID());
 		temp.setEndItem(_end);
@@ -1101,9 +1042,9 @@
 
 	@Override
-	public void updatePolygon() {
-		_poly = new Polygon();
-
-		Rectangle one;
-		Rectangle two;
+	public PolygonBounds updateBounds() {
+		PolygonBounds ret = new PolygonBounds();
+
+		AxisAlignedBoxBounds one;
+		AxisAlignedBoxBounds two;
 
 		/**
@@ -1121,12 +1062,12 @@
 			Item e = new Dot(_end.getX(), _end.getY(), -1);
 
-			one = s.getPolygon().getBounds();
-			two = e.getPolygon().getBounds();
+			one = AxisAlignedBoxBounds.getEnclosing(s.getBounds());
+			two = AxisAlignedBoxBounds.getEnclosing(e.getBounds());
 		} else {
 			Item s = new Dot(_start.getX(), _start.getY(), -1);
 			Item e = new Dot(_end.getX(), _end.getY(), -1);
 
-			one = e.getPolygon().getBounds();
-			two = s.getPolygon().getBounds();
+			one = AxisAlignedBoxBounds.getEnclosing(e.getBounds());
+			two = AxisAlignedBoxBounds.getEnclosing(s.getBounds());
 			/*
 			 * one = _end.getPolygon().getBounds(); two =
@@ -1136,17 +1077,18 @@
 
 		// if one is above two
-		if (one.getY() < two.getY()) {
-			_poly.addPoint((int) one.getMaxX(), (int) one.getMinY());
-			_poly.addPoint((int) two.getMaxX(), (int) two.getMinY());
-			_poly.addPoint((int) two.getMinX(), (int) two.getMaxY());
-			_poly.addPoint((int) one.getMinX(), (int) one.getMaxY());
+		if (one.getMinY() < two.getMinY()) {
+			ret.addPoint(one.getMaxX(), one.getMinY());
+			ret.addPoint(two.getMaxX(), two.getMinY());
+			ret.addPoint(two.getMinX(), two.getMaxY());
+			ret.addPoint(one.getMinX(), one.getMaxY());
 			// if one is below two
 		} else {
-			_poly.addPoint((int) one.getMinX(), (int) one.getMinY());
-			_poly.addPoint((int) two.getMinX(), (int) two.getMinY());
-			_poly.addPoint((int) two.getMaxX(), (int) two.getMaxY());
-			_poly.addPoint((int) one.getMaxX(), (int) one.getMaxY());
-		}
-
+			ret.addPoint(one.getMinX(), one.getMinY());
+			ret.addPoint(two.getMinX(), two.getMinY());
+			ret.addPoint(two.getMaxX(), two.getMaxY());
+			ret.addPoint(one.getMaxX(), one.getMaxY());
+		}
+		
+		return ret.close();
 	}
 
@@ -1199,5 +1141,5 @@
 
 	public double getLength() {
-		return getLength(_start.getPosition(), _end.getPosition());
+		return Point.distanceBetween(_start.getPosition(), _end.getPosition());
 	}
 
@@ -1210,10 +1152,10 @@
 	}
 
-	public static double getLength(Point p1, Point p2) {
-		return Point.distance(p1.x, p1.y, p2.x, p2.y);
-	}
-
-	@Override
-	public Rectangle[] getDrawingArea() { // TODO: CACHE - LIKE UPDATE POLYGON
+/*	public static double getLength(Point p1, Point p2) {
+		return Point.distance(p1, p2);
+	}*/
+
+	@Override
+	public AxisAlignedBoxBounds getDrawingArea() { // TODO: CACHE - LIKE UPDATE POLYGON
 
 		float currentThickness = this.getThickness() + 4;
@@ -1236,5 +1178,5 @@
 		y -= halfThickness;
 
-		Rectangle bounds = new Rectangle(x, y, w, h);
+		AxisAlignedBoxBounds bounds = new AxisAlignedBoxBounds(x, y, w, h);
 
 		// TODO: Cap bounds
@@ -1257,5 +1199,5 @@
 			 overall as opposed to advanced/expensive calculations for getting exact
 			 bounding box */
-			Rectangle arrowBounds = new Rectangle(_end.getX() - nArrowLength,
+			AxisAlignedBoxBounds arrowBounds = new AxisAlignedBoxBounds(_end.getX() - nArrowLength,
 					_end.getY() - nArrowLength, 2 * nArrowLength,
 					2 * nArrowLength);
@@ -1263,12 +1205,12 @@
 			if (currentThickness > 0.0f) {
 
-				arrowBounds = new Rectangle(arrowBounds.x - halfThickness,
-						arrowBounds.y - halfThickness, arrowBounds.width
-								+ thickness, arrowBounds.height + thickness);
-			}
-
-			return new Rectangle[] { bounds, arrowBounds };
+				arrowBounds = new AxisAlignedBoxBounds(arrowBounds.getMinX() - halfThickness,
+						arrowBounds.getMinY() - halfThickness, arrowBounds.getWidth()
+								+ thickness, arrowBounds.getHeight() + thickness);
+			}
+
+			return bounds.combineWith(arrowBounds);
 		} else {
-			return new Rectangle[] { bounds };
+			return bounds;
 		}
 
@@ -1294,3 +1236,9 @@
 	public void scale(Float scale, int originX, int originY) {
 	}
+
+	@Override
+	public float getSize()
+	{
+		return getThickness();
+	}
 }
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/AttractTextAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/AttractTextAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/AttractTextAction.java	(revision 1102)
@@ -1,6 +1,5 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import java.awt.Point;
-
+import org.expeditee.core.Point;
 import org.expeditee.gui.FrameUtils;
 import org.expeditee.items.Item;
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/BackspaceAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/BackspaceAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/BackspaceAction.java	(revision 1102)
@@ -1,5 +1,5 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
@@ -15,17 +15,17 @@
 		if(item.getParent() == null || !this.isSpIDERCodePage(item.getParent())) return false;
 		if(item == null || ((Text) item).isEmpty()) {
-			final Text temp = DisplayIO.getCurrentFrame().createNewText(".");
+			final Text temp = DisplayController.getCurrentFrame().createNewText(".");
 			callback(temp);
 			if(temp.getMagnetizedItemLeft() != -1) 
-				DisplayIO.setTextCursor((Text) temp.getParent().getItemWithID(temp.getMagnetizedItemLeft()), Text.END);
+				DisplayController.setTextCursor((Text) temp.getParent().getItemWithID(temp.getMagnetizedItemLeft()), Text.END);
 			else if(temp.getMagnetizedItemTop() != -1) 
-				DisplayIO.setTextCursor((Text) temp.getParent().getItemWithID(temp.getMagnetizedItemTop()), Text.END);
+				DisplayController.setTextCursor((Text) temp.getParent().getItemWithID(temp.getMagnetizedItemTop()), Text.END);
 			temp.delete();
 			callback(temp);
 			return true;
-		} else if(item.getMagnetizedItemLeft() != -1 && TextLogic.XIsBeforeCharacters((Text) item, DisplayIO.getMouseX())) {
+		} else if(item.getMagnetizedItemLeft() != -1 && TextLogic.XIsBeforeCharacters((Text) item, DisplayController.getMouseX())) {
 			new LastItemAction().exec(item);
 			return true;
-		} else if(item.getMagnetizedItemTop() != -1 && TextLogic.XIsBeforeCharacters((Text) item, DisplayIO.getMouseX())) {
+		} else if(item.getMagnetizedItemTop() != -1 && TextLogic.XIsBeforeCharacters((Text) item, DisplayController.getMouseX())) {
 			callback(item);
 			final Line currentLine = Line.getLineFromToken(item);
@@ -33,5 +33,5 @@
 			if(lastLine != null && Paragraph.getParagraphFromLine(lastLine).contains(currentLine)) {
 				lastLine.appendLine(currentLine);
-				DisplayIO.setTextCursor((Text) item, Text.HOME);
+				DisplayController.setTextCursor((Text) item, Text.HOME);
 				callback(item);
 				return true;
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/DeleteAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/DeleteAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/DeleteAction.java	(revision 1102)
@@ -1,5 +1,5 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
@@ -15,17 +15,17 @@
 		if(item.getParent() == null || !this.isSpIDERCodePage(item.getParent())) return false;
 		if(item == null || ((Text) item).isEmpty()) {
-			final Text temp = DisplayIO.getCurrentFrame().createNewText(".");
+			final Text temp = DisplayController.getCurrentFrame().createNewText(".");
 			callback(temp);
 			if(temp.getMagnetizedItemRight() != -1) 
-				DisplayIO.setTextCursor((Text) temp.getParent().getItemWithID(temp.getMagnetizedItemRight()), Text.HOME);
+				DisplayController.setTextCursor((Text) temp.getParent().getItemWithID(temp.getMagnetizedItemRight()), Text.HOME);
 			else if(temp.getMagnetizedItemBottom() != -1) 
-				DisplayIO.setTextCursor((Text) temp.getParent().getItemWithID(temp.getMagnetizedItemBottom()), Text.HOME);
+				DisplayController.setTextCursor((Text) temp.getParent().getItemWithID(temp.getMagnetizedItemBottom()), Text.HOME);
 			temp.delete();
 			callback(temp);
 			return true;
-		} else if(item.getMagnetizedItemRight() != -1 && TextLogic.XIsAfterCharacters((Text) item, DisplayIO.getMouseX())) {
+		} else if(item.getMagnetizedItemRight() != -1 && TextLogic.XIsAfterCharacters((Text) item, DisplayController.getMouseX())) {
 			new NextItemAction().exec(item);
 			return true;
-		} else if(item.getMagnetizedItemBottom() != -1 && TextLogic.XIsAfterCharacters((Text) item, DisplayIO.getMouseX())) {
+		} else if(item.getMagnetizedItemBottom() != -1 && TextLogic.XIsAfterCharacters((Text) item, DisplayController.getMouseX())) {
 			callback(item);
 			final Line currentLine = Line.getLineFromToken(item);
@@ -33,5 +33,5 @@
 			if(nextLine != null && Paragraph.getParagraphFromLine(currentLine).contains(nextLine)) {
 				currentLine.appendLine(nextLine);
-				DisplayIO.setTextCursor((Text) item, Text.END);
+				DisplayController.setTextCursor((Text) item, Text.END);
 				callback(item);
 				return true;
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/DownALineAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/DownALineAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/DownALineAction.java	(revision 1102)
@@ -1,5 +1,5 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
@@ -19,5 +19,5 @@
 		final int nextLineLength = 
 				nextLine.get(nextLine.size() - 1).getX() + nextLine.get(nextLine.size() - 1).getBoundsWidth() - nextLine.get(0).getX();
-		final int distanceThroughCurrentLine = DisplayIO.getMouseX() - startOfThisLine.getX();
+		final int distanceThroughCurrentLine = DisplayController.getMouseX() - startOfThisLine.getX();
 		if(distanceThroughCurrentLine <= nextLineLength) {
 			Item beneith = nextLine.get(0);
@@ -43,6 +43,6 @@
 		if(toMoveTo instanceof Text) {
 			final Text asText = (Text) toMoveTo;
-			DisplayIO.setTextCursor(asText, Text.END);
-		} else DisplayIO.setCursorPosition(toMoveTo.getPosition(), false);
+			DisplayController.setTextCursor(asText, Text.END);
+		} else DisplayController.setCursorPosition(toMoveTo.getPosition(), false);
 		return true;
 	}
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/LastItemAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/LastItemAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/LastItemAction.java	(revision 1102)
@@ -1,5 +1,5 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameUtils;
@@ -44,10 +44,10 @@
 //			DisplayIO.setCursorPosition(position.x + asText.getPixelBoundsUnion().width, position.y, false);
 //			FrameGraphics.refresh(false);
-			DisplayIO.setTextCursor((Text)toMoveTo, Text.END);
+			DisplayController.setTextCursor((Text)toMoveTo, Text.END);
 			if(FrameUtils.getCurrentItem() != toMoveTo) {
 				Line.getLineFromToken(toMoveFrom).deltaX(1);
 				moveCursor(toMoveTo, toMoveFrom);
 			}
-		} else DisplayIO.setCursorPosition(toMoveTo.getPosition(), false);
+		} else DisplayController.setCursorPosition(toMoveTo.getPosition(), false);
 		return true;
 	}
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/NextItemAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/NextItemAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/NextItemAction.java	(revision 1102)
@@ -1,5 +1,5 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import org.expeditee.gui.DisplayIO;
+import org.expeditee.gui.DisplayController;
 import org.expeditee.items.Item;
 import org.expeditee.items.Text;
@@ -34,5 +34,5 @@
 			return false;
 		//System.err.println("Next item requests move to item with text: " + toMoveTo.getText());
-		DisplayIO.setTextCursor((Text)toMoveTo, Text.HOME);
+		DisplayController.setTextCursor((Text)toMoveTo, Text.HOME);
 		return true;
 	}
Index: /trunk/src/org/expeditee/items/MagneticConstraint/Actions/RepelTextAction.java
===================================================================
--- /trunk/src/org/expeditee/items/MagneticConstraint/Actions/RepelTextAction.java	(revision 1101)
+++ /trunk/src/org/expeditee/items/MagneticConstraint/Actions/RepelTextAction.java	(revision 1102)
@@ -1,7 +1,6 @@
 package org.expeditee.items.MagneticConstraint.Actions;
 
-import java.awt.Point;
-
-import org.expeditee.gui.Browser;
+import org.expeditee.core.Point;
+import org.expeditee.gio.EcosystemManager;
 import org.expeditee.gui.FrameUtils;
 import org.expeditee.items.Item;
@@ -45,5 +44,5 @@
 			return false;
 		} else {
-			final int charDistance = Browser._theBrowser.getFontMetrics(((Text)item).getFont()).stringWidth("X");
+			final int charDistance = EcosystemManager.getTextLayoutManager().getStringWidth(((Text)item).getFont(), "X");
 			final Line tokensToMove = Line.getLineFromToken(item);
 			tokensToMove.removeFirst();
